// 创建编辑器元素
var E = window.wangEditor;
var editor = new E('#toolbar', '#text'); // 两个参数也可以传入 elem 对象，class 选择器
// 菜单配置
editor.customConfig.menus = [
  'bold', // 粗体
  'italic', // 斜体
  'underline', // 下划线
  'strikeThrough', // 删除线
  'image', // 插入图片
]
// // utf8mb4 正则
// const utf8mb4Reg = /[^\u0000-\uFFFF]/g; // eslint-disable-line
// // emoji 表情正则
// const emojiReg =
//     /(\ud83c[\udf00-\udfff])|(\ud83d[\udc00-\ude4f])|(\ud83d[\ude80-\udeff])/g;
// // 包含 utf8mb4 的 4 字节
// const isUTF8MB4 = utf8mb4Reg.test(editor.txt.text());
// // 包含 emoji 表情
// const isEmoj = emojiReg.test(editor.txt.text());

// editor.customConfig.onchange = function (num) {

//   // utf8mb4 正则
//   var utf8mb4Reg = /[^\u0000-\uFFFF]/g; // eslint-disable-line
//   // emoji 表情正则
//   var emojiReg =
//       /(\ud83c[\udf00-\udfff])|(\ud83d[\udc00-\ude4f])|(\ud83d[\ude80-\udeff])/g;
//   // 包含 utf8mb4 的 4 字节
//   var isUTF8MB4 = utf8mb4Reg.test(editor.txt.text());
//   // 包含 emoji 表情
//   var isEmoj = emojiReg.test(editor.txt.text());

//   // 校验特殊字符 并删除
//   // isUTF8MB4 && (editor1.txt.text() = editor1.txt.text().replace(utf8mb4Reg, ''));
//   // isEmoj && (editor1.txt.text() = editor1.txt.text().replace(emojiReg, ''));


//   // 监控变化，同步更新到 span
//   console.log('输入', editor.txt.text(),editor.txt.text().replace(emojiReg, ''), editor.txt.text().length, '字了')
//   if(isEmoj){
//     console.log("有表情")
//     alert("请不要插入表情")
//     var savetxt = editor.txt.text().replace(emojiReg, '')
//     console.log(savetxt,"清除前保留")
//     editor.txt.clear()
//     editor.txt.append(`<p>${savetxt}</p>`) 
//   }
// }

// 隐藏 网络图片tab
editor.customConfig.showLinkImg = false;
// 使用 base64 保存图片
editor.customConfig.uploadImgShowBase64 = true;
// 配置编辑区域的 z-index
editor.customConfig.zIndex = 9;
// 限制图片大小
editor.customConfig.uploadImgMaxSize = 2 * 1024 * 1024 // 2M
// 限制上传数量
editor.customConfig.uploadImgMaxLength = 5 // 一次最多上传 5 个图片
// 背景颜色
bgColorQuery();

function bgColorQuery() {
  let paramsBg = getQueryString(location.href, 'bgcolor')
  let editorBg = paramsBg.slice(2, paramsBg.length);
  // var editorBg = queryUrlParame().bgcolor.slice(2);
  document.querySelector('.toolbar').style.backgroundColor = '#' + editorBg;
  document.querySelector('#text').style.backgroundColor = '#' + editorBg;
}


// 编辑器创建并挂载
editor.create();
// 解决第一次选择菜单工具条无反应问题
document.querySelector('.w-e-icon-bold').click();
// 隐藏编辑区滚动条
document.querySelector('.w-e-text').style.overflow = 'auto';

function handleadd(){
//   var str = "追加的内容"
//   editor.txt.append(`<p>${str}</p>`)
  saveHandle()
}

handleToolBarClick()
// 处理点击选中问题
function handleToolBarClick(){
  let toolBar = document.querySelector('.w-e-toolbar');
  toolBar.addEventListener('click', function(event){
    // console.log(event.target);
    let curDom = event.target;
    let classList =  Array.from(curDom.classList);
    if(curDom.nodeName == 'I'){
      curDom = curDom.parentNode;
      // console.log(curDom)
    } else if(curDom.nodeName == 'DIV' && classList.indexOf('w-e-menu') == -1){
      return
    }
    
    if(Array.from(curDom.classList).indexOf('w-e-active') != -1){ // 说明已经被选中
      
    } else { // 没有被选中
      let curDomSiblings = siblings(curDom);
      // console.log(curDomSiblings)
      for(let i = 0; i < curDomSiblings.length; i++){
        let item = curDomSiblings[i];
        if(Array.from(item.classList).indexOf('w-e-active') != -1){
          // console.log('有被选中的，点了个没被选中的')
          curDom.click()
        }
      }
    }
  })
}
// 获取元素的兄弟元素（除了自己）
function siblings(elm) {
  var a = [];
  var p = elm.parentNode.children;
  for(var i =0,pl= p.length;i<pl;i++) {
    if(p[i] !== elm) a.push(p[i]);
  }
  return a;
}



// 保存逻辑
// saveHandle();
function saveHandle() {
  // 读取 html
  var html = editor.txt.html();
  console.log(html,13212312)
  // var reg = /<p>(.*?)<\/p>/g;
  let reg=/<\/?.+?\/?>/g;
  let firstIsImg = html.indexOf('<img src="data:image/') == 3 || html.indexOf('<img src="data:image/') == 14 ? true : false;
  var title = html.replace(reg, '').replace('<br>', '').replace('&nbsp;', '').replace(/(\ud83c[\udf00-\udfff])|(\ud83d[\udc00-\ude4f])|(\ud83d[\ude80-\udeff])/g, '');
  title = title.length > 30 ? title.slice(0, 30) : title.slice(0);
  if (firstIsImg) {
    title = '[图片]'
  }
  try {
    Cef ? Cef.SaveText2(html, title) : ''
  } catch (err) {
    localStorage.setItem('notesContent', html);
    prompt('getNotesContent', title)
    // prompt(JSON.stringify({"name":"jiexian"}))
  }
}

// 保存作答题逻辑
// saveAnswerText();
function saveAnswerText() {
  // document.querySelector('#btn').addEventListener('click', function () {
  // 读取 html
  var html = editor.txt.html();
  // var reg = /<p>(.*?)<\/p>/g;
  let reg=/<\/?.+?\/?>/g;
  let firstIsImg = html.indexOf('<img src="data:image/') == 3 ? true : false;

  var title = html.replace(reg, '').replace('<br>', '').replace('&nbsp;', '');
  title = title.length > 10 ? title.slice(0, 10) : title.slice(0);
  if (firstIsImg) {
    title = '[图片]'
  }
  // 客户端交互
  Cef.SaveAnswerText(html, title);
  // console.log(title);
  // }, false)
}

// 内容回显
// showHandle();
function showHandle(str) {
  if (!str) {
    let storageStr = (localStorage.getItem('notesContent'));
    if (storageStr) {
      str = (storageStr)
      // let strObj = JSON.parse(storageStr);
      // str = strObj.html;
    }
  }
  // document.querySelector('#show').addEventListener('click', function () {
  // 回显 html
  // editor.txt.html(`<p>当前，大部分使用 <span style="font-weight: bold; font-style: italic; text-decoration-line: underline line-through;">TypeScript </span>的 Vue 开发者都在通过&nbsp;<code>vue-class-component</code>&nbsp;这个库将组件撰写为 TypeScript class (借助 decorator)。我们在设计 3.0 时曾有<a href="https://github.com/vuejs/rfcs/pull/17" target="_blank" rel="noopener noreferrer">一个已废弃的 RFC<svg xmlns="http://www.w3.org/2000/svg" aria-hidden="true" x="0px" y="0px" viewBox="0 0 100 100" width="15" height="15"><path fill="currentColor" d="M18.8,85.1h56l0,0c2.2,0,4-1.8,4-4v-32h-8v28h-48v-48h28v-8h-32l0,0c-2.2,0-4,1.8-4,4v56C14.8,83.3,16.6,85.1,18.8,85.1z"></path><polygon fill="currentColor" points="45.7,48.7 51.3,54.3 77.2,28.5 77.2,37.2 85.2,37.2 85.2,14.9 62.8,14.9 62.8,22.9 71.5,22.9"></polygon></svg></a>，希望提供一个内建的 Class API 来更好的解决类型问题。然而当讨论并迭代其具体设计时，我们注意到，想通过 Class API 来解决类型问题，就必须依赖 decorator——一个在实现细节上存在许多未知数的非常不稳定的 stage 2 提&nbsp;&nbsp;<br></p>`)
  editor.txt.html(str);
  // }, false)
}

// 重置背景颜色，PC端调用
// resetBg('ff008899')
function resetBg(color) {
  color = color.slice(2);
  document.querySelector('.toolbar').style.backgroundColor = '#' + color;
  document.querySelector('#text').style.backgroundColor = '#' + color;
}

// 遍历url参数字符串
function queryUrlParame() {
  var queryStr = window.location.search;
  var querayObj = {};
  queryStr = queryStr.slice(1);
  var queryArr = queryStr.split('&');
  for (var i = 0; i < queryArr.length; i++) {
    var queryParame = queryArr[i].split('=');
    querayObj[queryParame[0]] = queryParame[1];
  }
  return querayObj;
}


/*  获取URl中的参数
 * @para url 
 * @para key 参数名*/
function getQueryString(url) {
  var left = url.indexOf("?") + 1
  var right = url.lastIndexOf("#")
  if (right == -1) {
    right = url.length;
  }
  var parasString = url.slice(left, right)
  var paras = parasString.split('&');
  var parasjson = {}
  paras.forEach(function (value, index, arr) {
    var a = value.split('=');
    parasjson[a[0]] !== undefined ? parasjson[a[0]] = [].concat(parasjson[a[0]], a[1]) : parasjson[a[0]] = a[1];
  });
  let result = arguments[1] !== void 0 ? (parasjson[arguments[1]] || '') : parasjson;
  return result
}



/**
 *  画板组件
 *  at 20190129
 * @param {any} id
 * @param {any} pImg
 */
 var CanvasBoard = function(id, pImg) {
  this.canvas = "";
  this.context = "";
  this.eraserEnabled = "";
  this.lineWidth = 1;
  this.penSize = 1;
  this.canvasTop = this.title;
  this.scrollTop = 0;
  this.scrollLeft = 0;
  this.canvasWidth = "";
  this.canvasHeight = "";
  this.cPushArray = [];
  this.cStep = -1;
  this.addShow = true;
  this.isClick = false; //画笔是否已点击
  this.postImg = pImg;

  this.$parent = $("#" + id);

  this.init = function () {
      var canvasDiv = $('<div id="drawBox" class="drawBox">'+
          '<div style="overflow:hidden;">'+
          '<div id="canvasWrapper" style="">'+
          '<div id="canvasBox">'+
          '<canvas id="canvas" ></canvas>'+
          '<ul id="actions" class="actions">'+
          '<li class="" id="clearBtn"> '+
          '<img src="img/del.png" alt=""> '+
          '</li> '+
          '<li class="" id="cUndoBtn"><img src="img/backPrev.png" alt=""></li> '+
          '<li class="" id="cRedoBtn"><img src="img/backNext.png" alt=""></li> '+
          '<li class="" id="eraserBtn"><img src="img/eraser.png" alt=""></li> '+
          '<li class="active" id="penBtn"><img src="img/brush.png" alt=""></li> '+
          // '<div class="penSetting"> '+
          // '<div class="pTit">笔设置</div> '+
          // '<div class="pSize"> '+
          // '<p class="clearfix"> '+
          // '<span class="fl">大小</span>'+
          // '<span class="fr sizeSpan">'+this.penSize+'</span> '+
          // '</p> '+
          // '<input type="range" min="1" max="8" step="1" value="'+this.penSize+'" id="setPensize"> '+
          // '</div> '+
          // '<ul class="pColor clearfix"> '+
          // '<li id="c1" class="" style="background: #EFDCD3;"></li> '+
          // '<li id="c2" class="" style="background: #F59999;"></li> '+
          // '<li id="c3" class="" style="background: #E86262;"></li> '+
          // '<li id="c4" class="" style="background: #AA4446;"></li> '+
          // '<li id="c5" class="" style="background: #6B4849;"></li> '+
          // '<li id="c6" class="active" style="background: #34231E;"></li> '+
          // '<li id="c7" class="" style="background: #435772;"></li> '+
          // '<li id="c8" class="" style="background: #2DA4A8;"></li> '+
          // '<li id="c9" class="" style="background: #FEAA3A;"></li> '+
          // '<li id="c10" class="" style="background: #FD6041;"></li> '+
          // '<li id="c11" class="" style="background: #CF2257;"></li> '+
          // '<li id="c12" class="" style="background: #404040;"></li> '+
          // '<li id="c13" class="" style="background: #92BEE2;"></li> '+
          // '<li id="c14" class="" style="background: #2286D8;"></li> '+
          // '</ul> '+
          // '</div> '+
          '<div class="fr"> '+
          '<a href="javascript:;" class="back">返回</a> '+
          '<a href="javascript:;" class="submitCanvas">提交</a> '+
          '</div> '+
          '</ul> '+
          '</div></div> '+
          // '<div class="dragBox" id="dragBox"></div> '+
          '</div></div>');

      var that = this;
      that.$parent.append(canvasDiv);
      that.canvas = document.getElementById('canvas');
      that.context = that.canvas.getContext('2d');
      that.cPushArray = [];
      // that.dragCanvas();
      $("#canvas").attr("width",$("#canvasWrapper").width());
      $("#canvas").attr("height",$("#canvasWrapper").height());
      $("#dragBox").css("top", "16.9%");
      $("#actions").css("top", "18.7%");
      that.autoSetCanvasSize(that.canvas, "1");
      that.listenToUser(that.canvas);
      that.eraserEnabled = false;
      that.lineWidth = that.penSize;
      that.context.fillStyle = '#34231E';
      that.context.strokeStyle = '#34231E';
      that.cStep = -1;

      if (that.postImg != "") {
          that.loadImage();
      }

      //画笔点击
      $("#penBtn").on("click", function () {
          that.eraserEnabled = false;
          $(this).addClass('active').siblings("li").removeClass('active');
          if (!that.isClick) {
            //   window.removeEventListener("touchmove", isScroll);
              $(".penSetting").show();
              that.isClick = true;
          } else {
            //   window.addEventListener("touchmove", isScroll, { passive: false });
              $(".penSetting").hide();
              that.isClick = false;
          }
       });

      //橡皮点击
      $("#eraserBtn").on("click", function () {
          $(this).addClass('active').siblings("li").removeClass('active');
          that.eraserEnabled = true;
          $(".penSetting").hide();
          that.isClick = false;
      });

      //清除点击
      $("#clearBtn").on("click", function () {
          $(this).addClass('active').siblings("li").removeClass('active');
          that.context.clearRect(0, 0, that.canvas.width, that.canvas.height);
          $(".penSetting").hide();
          that.isClick = false;
          that.cPush();
      });

      //撤销点击
      $("#cUndoBtn").on("click", function () {
          $(this).addClass('active').siblings("li").removeClass('active');
          if (that.cStep >= 0) {
              that.cStep--;
              if (that.cStep == -1) {
                  that.context.clearRect(0, 0, that.canvas.width, that.canvas.height);
              } else {
                  that.cGet(that.cStep);
              }
          }
          $(".penSetting").hide();
          that.isClick = false;
      });

      //恢复点击
      $("#cRedoBtn").on("click", function () {
          $(this).addClass('active').siblings("li").removeClass('active');
          if (that.cStep < that.cPushArray.length - 1) {
              that.cStep++;
              that.cGet(that.cStep);
          }
          $(".penSetting").hide();
          that.isClick = false;
      });

      //画布扩展宽度
      $("#addWidth").on("click", function () {
          $(this).addClass('active').siblings("li").removeClass('active');
          that.canvasWidth = parseInt(that.canvasWidth) + 100;
          $("#canvas").width(that.canvasWidth);
          $("#canvas").attr("width",that.canvasWidth);
          that.autoSetCanvasSize(that.canvas, "3");
          that.cGet(that.cStep);
          $("#canvasWrapper").scroll(function () {
              that.scrollLeft = $("#canvasWrapper").scrollLeft();
          });
          $(".penSetting").hide();
          that.isClick = false;
      });

      //画布扩展高度
      $("#addHeight").on("click", function () {
          $(this).addClass('active').siblings("li").removeClass('active');
          that.canvasHeight = parseInt(that.canvasHeight) + 100;
          $("#canvas").height(that.canvasHeight);
          $("#canvas").attr("height", that.canvasHeight);
          //平板滚动条动态加高
          $(".hScroll").height(that.canvasHeight);
          $(".wScroll").css("top", that.canvasHeight + "px");

          that.autoSetCanvasSize(that.canvas, "3");
          that.cGet(that.cStep);
          $("#canvasWrapper").scroll(function () {
              that.scrollTop = $("#canvasWrapper").scrollTop();
          });
          $(".penSetting").hide();
          that.isClick = false;
      });

      //画笔颜色选择
      $(".pColor li").on("click", function () {
          $(this).addClass('active').siblings("li").removeClass('active');
          var thisColor = $(this).css("background-color");
          that.context.fillStyle = thisColor;
          that.context.strokeStyle = thisColor;
      });

      //返回作答点击
      $(".back").on("click", function () {
          that.context.clearRect(0, 0, that.canvas.width, that.canvas.height);
          $(".wScroll").width(that.canvas.width);
          $(".hScroll").css("left", that.canvas.width + "px");
          // window.removeEventListener("touchmove", isScroll);
          $("#text").show()
          $("#jbox").show()
          $(".hScroll").height(that.canvas.height);
          $(".wScroll").css("top", that.canvas.height + "px");
          $("#drawBox").remove();
      });

      //提交点击
      $(".submitCanvas").on("click", function () {
          var url = that.canvas.toDataURL("image/png");
          that.context.clearRect(0, 0, that.canvas.width, that.canvas.height);
          $(".wScroll").width(that.canvas.width);
          $(".hScroll").css("left", that.canvas.width + "px");

          $(".hScroll").height(that.canvas.height);
          $(".wScroll").css("top", that.canvas.height + "px");
          // window.removeEventListener("touchmove", isScroll);
          $("#text").show()
          $("#jbox").show()
          editor.txt.append(`<p><img src="${url}" alt="" width="200" height="auto" /></p>`)
          $("#imgBox").attr("src", url);
          $("#drawBox").remove();
      });
      
      //修改画笔大小
      $("#setPensize").on("input", function () {
          var value = $(this).val();
          that.penSize = value;
          $(".sizeSpan").text(value);
          $(this).css('background-size', value / 8 * 100 + '% 100%');
      });
  };

  //重定义canvas宽高
  this.autoSetCanvasSize = function (canvas, index) { 
      var that = this;
      that.setCanvasSize(canvas, index)
      window.onresize = function () {
          that.setCanvasSize(canvas, index)
      }
  };

  //重定义canvas宽高
  this.setCanvasSize = function (canvas, index) {
      var that = this;
      var pageWidth = document.getElementById("canvas").clientWidth;
      var pageHeight = document.getElementById("canvas").clientHeight;
      that.canvasTop = $("#canvasWrapper").offset().top;
      that.canvasWidth = pageWidth;
      that.canvasHeight = pageHeight;
  };

  //画曲线
  this.drawCircle = function (x, y, radius) {
      var that = this;
      $(".penSetting").hide();
      that.isClick = false;
      that.context.beginPath()
      that.context.arc(x, y, radius, 0, Math.PI * 2);
      that.context.fill();
  };

  //画直线
  this.drawLine = function (x1, y1, x2, y2) {
      var that = this;
      $(".penSetting").hide();
      that.isClick = false;
      that.context.beginPath();
      that.context.moveTo(x1, y1) // 起点
      that.context.lineWidth = that.penSize;
      that.context.lineTo(x2, y2); // 终点
      that.context.stroke();
      that.context.closePath();
  };

  this.listenToUser= function(canvas) {
      var that = this;
      var using = false;
      var lastPoint = {
          x: undefined,
          y: undefined
      }
      // 特性检测
      if (document.body.ontouchstart !== undefined) {
          // 触屏设备
          canvas.ontouchstart = function (obj) {
              var x = obj.touches[0].clientX;
              var y = obj.touches[0].clientY;
              using = true;
              if (that.eraserEnabled) {
                  that.context.clearRect(x - 5 + that.scrollLeft, y - 5 - that.canvasTop + that.scrollTop, 20, 20)
                  $("#canvasWrapper").css("overflow", "hidden");
              } else {
                  lastPoint = {
                      "x": x,
                      "y": y
                  }
                  $("#canvasWrapper").css("overflow", "hidden");
              }
          }
          canvas.ontouchmove = function (obj) {
              var x = obj.touches[0].clientX
              var y = obj.touches[0].clientY
              if (!using) {
                  return
              }
              if (that.eraserEnabled) {
                  that.context.clearRect(x - 5 + that.scrollLeft, y - 5 - that.canvasTop + that.scrollTop, 20, 20)
              } else {
                  var newPoint = {
                      "x": x,
                      "y": y
                  }
                  that.drawLine(lastPoint.x + that.scrollLeft, lastPoint.y - that.canvasTop + that.scrollTop, newPoint.x + that.scrollLeft, newPoint.y - that.canvasTop + that.scrollTop)
                  lastPoint = newPoint;
              }
          }
          canvas.ontouchend = function (e) {
              that.cPush();
              using = false;
              $("#canvasWrapper").css("overflow", "auto");
          }
      }else {
          // 非触屏设备
          canvas.onmousedown = function (obj) {
              var x = obj.clientX;
              var y = obj.clientY;
              using = true;
              if (that.eraserEnabled) {
                  that.context.clearRect(x - 5 + that.scrollLeft, y - 5 - that.canvasTop + that.scrollTop, 20, 20)
                  $("#canvasWrapper").css("overflow", "hidden");
              } else {
                  lastPoint = {
                      "x": x,
                      "y": y
                  }
                  $("#canvasWrapper").css("overflow", "hidden");
              }
          }
          canvas.onmousemove = function (obj) {
              var x = obj.clientX
              var y = obj.clientY
              if (!using) {
                  return
              }
              if (that.eraserEnabled) {
                  that.context.clearRect(x - 5 + that.scrollLeft, y - 5 - that.canvasTop + that.scrollTop, 20, 20)
              } else {
                  var newPoint = {
                      "x": x,
                      "y": y
                  }
                  that.drawLine(lastPoint.x + that.scrollLeft, lastPoint.y - that.canvasTop + that.scrollTop, newPoint.x + that.scrollLeft, newPoint.y - that.canvasTop + that.scrollTop)
                  lastPoint = newPoint;
              }
          }
          canvas.onmouseup = function (obj) {
              that.cPush();
              using = false;
              $("#canvasWrapper").css("overflow", "auto");
          }
      }

  };

  //拖动改变画板高度
  // this.dragCanvas= function() {
  //     var that = this;
  //     var oDiv1 = document.getElementById('drawBox');
  //     var oDiv2 = document.getElementById('canvasWrapper');
  //     var oDiv3 = document.getElementById('dragBox');
  //     var oDiv4 = document.getElementById('actions');
  //     var oDiv5 = document.getElementById('canvas');
  //     if (document.body.ontouchstart !== undefined) {
  //         var startY = 0,
  //             sY = 0,
  //             moveY = 0,
  //             topY = 0;
  //         $("#dragBox").on({ //绑定事件
  //             touchstart: function (e) {
  //                 startY = e.originalEvent.targetTouches[0].pageY; //获取点击点的Y坐标
  //                 sY = $(this).offset().top; //相对于当前窗口Y轴的偏移量
  //                 topY = startY - sY; //鼠标所能移动的最上端是当前鼠标距div上边距的位置
  //             },
  //             touchmove: function (e) {
  //                 e.preventDefault();
  //                 moveY = e.originalEvent.targetTouches[0].pageY; //移动过程中Y轴的坐标
  //                 var objY = moveY - topY;
  //                 if (objY >= 0 && objY <= oDiv1.offsetHeight) {
  //                     $("#dragBox").css("top", objY - oDiv3.offsetHeight - 2 + 'px');
  //                     $('#canvasWrapper').height(oDiv1.offsetHeight - objY - 12 + 'px');
  //                     $("#canvas").height(oDiv1.offsetHeight - objY - 12 + 'px');
  //                     $("#canvas").attr("height",oDiv1.offsetHeight - objY - 12 + 'px');
  //                     $("#actions").css("top", objY - oDiv3.offsetHeight + 12 + 'px');
  //                     //平板滚动条动态加高
  //                     $(".hScroll").height(oDiv1.offsetHeight - objY - 12 + 'px');
  //                     $(".wScroll").css("top", oDiv1.offsetHeight - objY - 12 + 'px');

  //                     that.autoSetCanvasSize(that.canvas, "2");
  //                 }
  //             },
  //             touchend: function (e) {
  //                 that.cGet(that.cStep);
  //             }
  //         });
  //     } else {
  //         oDiv3.onmousedown = function (ev) {
  //             var oEvent = ev || event;
  //             document.onmousemove = function (ev) {
  //                 var oEvent = ev || event;
  //                 if (oEvent.clientY >= 0 && oEvent.clientY <= oDiv1.offsetHeight) {
  //                     oDiv3.style.top = oEvent.clientY - oDiv3.offsetHeight - 2 + 'px';
  //                     oDiv2.style.height = oDiv1.offsetHeight - oEvent.clientY + 'px';
  //                     oDiv5.style.height = oDiv1.offsetHeight - oEvent.clientY + 'px';
  //                     oDiv5.height = oDiv1.offsetHeight - oEvent.clientY;
  //                     oDiv4.style.top = oEvent.clientY - oDiv3.offsetHeight + 12 + 'px';
  //                     that.autoSetCanvasSize(that.canvas, "2");
  //                 }
  //             }
  //             document.onmouseup = function () {
  //                 that.cGet(that.cStep);
  //                 document.onmousemove = null;
  //                 document.onmouseup = null;
  //             }
  //         }
  //     }


  // };

  this.loadImage= function() {
      var that = this;
      var image = new Image();
      image.src = that.postImg;
      $(image).load(function () {
          that.context.drawImage(image, 0, 0);
          that.cPush();
      });
  };

  this.cPush = function () {
      var that = this;
      that.cStep++;
      if (that.cStep < that.cPushArray.length) { that.cPushArray.length = that.cStep; }
      that.cPushArray.push(that.canvas.toDataURL());
  };

  this.cGet= function(step) {
      var that = this;
      var canvasPic = new Image();
      if (that.cPushArray[step] != "" && that.cPushArray[step] != undefined) {
          canvasPic.src = that.cPushArray[step];
          canvasPic.onload = function () {
              that.context.clearRect(0, 0, that.canvas.width, that.canvas.height);
              that.context.drawImage(canvasPic, 0, 0);
          }
      }
  };

  

  

  









};